/*
 * Copyright 1991, 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include "is_types.h"

#ifndef lint
static	char	sccsid[] = "@(#)db_close.c	1.3	12:27:10	1/28/92";
#endif

extern	int	db_errno;

int
__db_close_file (dbm, file)
dbm_t	*dbm;
file_t	*file;
{
	if (file->f_schema->s_fields) {
		free (file->f_schema->s_fields);
		file->f_schema->s_fields = 0;
	} else
		return (db_errno = DB_NOTOPEN), -1;

	if (file->f_index) {
		free (file->f_index->i_keys);
		free (file->f_index);
		file->f_index = 0;
	}
	if (file->f_current_view) {
		free (file->f_current_view->v_fields);
		free (file->f_current_view->v_offsets);
		free (file->f_current_view->v_buffer);
		file->f_current_view = 0;
	}
	if (file->f_data_buffer)
		free (file->f_data_buffer);

	return isam_close (file);
}

int
db_close_file (dbm, filenum)
dbm_t	*dbm;
int	filenum;
{
	file_t	*file;

	if (filenum < 0 || filenum >= dbm->d_file_count ||
			dbm->d_files[filenum].f_file_name[0] == '\0')
		return (db_errno = DB_INVALID), -1;

	return __db_close_file (dbm, &dbm->d_files[filenum]);
}

db_close (dbm)
dbm_t	*dbm;
{
	int	i;

	for (i = 0;i < dbm->d_file_count;i++) {
		if (dbm->d_files[i].f_schema) {
			if (dbm->d_files[i].f_schema->s_fields)
				if (__db_close_file (dbm, &dbm->d_files[i]))
					return -1;

			free (dbm->d_files[i].f_schema);
		}
	}
	free (dbm->d_files);

	return 0;
}
